# coding: utf-8

"""
    Asana

    This is the interface for interacting with the [Asana Platform](https://developers.asana.com). Our API reference is generated from our [OpenAPI spec] (https://raw.githubusercontent.com/Asana/openapi/master/defs/asana_oas.yaml).  # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class TaskDuplicateRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'include': 'str'
    }

    attribute_map = {
        'name': 'name',
        'include': 'include'
    }

    def __init__(self, name=None, include=None):  # noqa: E501
        """TaskDuplicateRequest - a model defined in Swagger"""  # noqa: E501
        self._name = None
        self._include = None
        self.discriminator = None
        if name is not None:
            self.name = name
        if include is not None:
            self.include = include

    @property
    def name(self):
        """Gets the name of this TaskDuplicateRequest.  # noqa: E501

        The name of the new task.  # noqa: E501

        :return: The name of this TaskDuplicateRequest.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this TaskDuplicateRequest.

        The name of the new task.  # noqa: E501

        :param name: The name of this TaskDuplicateRequest.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def include(self):
        """Gets the include of this TaskDuplicateRequest.  # noqa: E501

        The fields that will be duplicated to the new task.  # noqa: E501

        :return: The include of this TaskDuplicateRequest.  # noqa: E501
        :rtype: str
        """
        return self._include

    @include.setter
    def include(self, include):
        """Sets the include of this TaskDuplicateRequest.

        The fields that will be duplicated to the new task.  # noqa: E501

        :param include: The include of this TaskDuplicateRequest.  # noqa: E501
        :type: str
        """
        allowed_values = ["notes", "assignee", "subtasks", "attachments", "tags", "followers", "projects", "dates", "dependencies", "parent"]  # noqa: E501
        if include not in allowed_values:
            raise ValueError(
                "Invalid value for `include` ({0}), must be one of {1}"  # noqa: E501
                .format(include, allowed_values)
            )

        self._include = include

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(TaskDuplicateRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TaskDuplicateRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
